﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Windows.Threading;

namespace ChatBySocketIoClientDotNet
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        string name = Environment.MachineName;
        Quobject.SocketIoClientDotNet.Client.Socket socket;

        public MainWindow()
        {
            InitializeComponent();
            socket = Quobject.SocketIoClientDotNet.Client.IO.Socket("http://localhost:1337");

            socket.On("message", (data) =>
            {
                Dispatcher.Invoke(new Action(() => {
                    OutputTextBox.Text += "reply: " + data + Environment.NewLine;
                }), DispatcherPriority.ContextIdle);
            });
        }

        private void SendButton_Click(object sender, RoutedEventArgs e)
        {
            socket.Emit("message", InputTextBox.Text);
            OutputTextBox.Text += name + ": " + InputTextBox.Text + Environment.NewLine;
            InputTextBox.Text = "";

            // ScrollBar to Bottom
            OutputTextBox.Focus();
            OutputTextBox.CaretIndex = OutputTextBox.Text.Length;
            OutputTextBox.ScrollToEnd();

            // Focus to Input
            InputTextBox.Focus();
        }
    }
}
